//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2024-03-22 15:44:31 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Application.ViewModel;
using FellowOakDicom.Network.Client;
using FellowOakDicom.Network;
using IRaCIS.Application.Contracts;
using IRaCIS.Core.Domain.Share;
namespace IRaCIS.Core.Application.Service
{
    /// <summary>
    /// DicomAEService
    /// </summary>	
    [ApiExplorerSettings(GroupName = "Trial")]
    public class TrialDicomAEService : BaseService, IDicomAEService
    {

        private readonly IRepository<TrialDicomAE> _dicomAERepository;
        private readonly IRepository<Trial> _trialRepository;

        public TrialDicomAEService(IRepository<TrialDicomAE> dicomAERepository, IRepository<Trial> trialRepository)
        {
            _trialRepository = trialRepository;
            _dicomAERepository = dicomAERepository;
        }

        [HttpPost]
        public async Task<IResponseOutput<PageOutput<DicomAEView>>> GetDicomAEList(DicomAEQuery inQuery)
        {

            var dicomAEQueryable = _dicomAERepository
                               .WhereIf(!string.IsNullOrWhiteSpace(inQuery.IP), t => t.IP.Contains(inQuery.IP))
                               .WhereIf(inQuery.Port != null, t => t.Port == inQuery.Port)
                               .WhereIf(!string.IsNullOrWhiteSpace(inQuery.CalledAE), t => t.CalledAE.Contains(inQuery.CalledAE))
                               .WhereIf(!string.IsNullOrWhiteSpace(inQuery.Description), t => t.Description.Contains(inQuery.Description))
                               .WhereIf(!string.IsNullOrWhiteSpace(inQuery.Modality), t => t.Modality.Contains(inQuery.Modality))
                               .ProjectTo<DicomAEView>(_mapper.ConfigurationProvider);




            var pageList = await dicomAEQueryable.ToPagedListAsync(inQuery.PageIndex, inQuery.PageSize, inQuery.SortField == string.Empty ? nameof(DicomAEView.CalledAE) : inQuery.SortField, inQuery.Asc);


            return ResponseOutput.Ok(pageList);
        }


        /// <summary>
        /// 获取项目dicom AE 配置信息，otherinfo里面有IsPACSConnect  IsTrialPACSConfirmed
        /// </summary>
        /// <param name="trialId"></param>
        /// <returns></returns>
        public async Task<IResponseOutput<DicomAEView>> GetTrialDicomAE(Guid trialId)
        {
            var dicomAE = _dicomAERepository.Where(t => t.TrialId == trialId).ProjectTo<DicomAEView>(_mapper.ConfigurationProvider).FirstOrDefault();
            var trialConfig = await _trialRepository.Where(t => t.Id == trialId).Select(t => new { t.IsPACSConnect, t.IsTrialPACSConfirmed }).FirstOrDefaultAsync();
            return ResponseOutput.Ok(dicomAE, trialConfig);

        }


        public async Task<IResponseOutput> AddOrUpdateDicomAE(DicomAEAddOrEdit addOrEditDicomAE)
        {
            var verifyExp1 = new EntityVerifyExp<TrialDicomAE>()
            {
                VerifyExp = u => u.IP == addOrEditDicomAE.IP && u.Port == addOrEditDicomAE.Port && u.TrialId == addOrEditDicomAE.TrialId,

                VerifyMsg = "不允许添加相同的IP和端口的记录"
            };

            //var verifyExp2 = new EntityVerifyExp<TrialDicomAE>()
            //{
            //    VerifyExp = u =>  u.TrialId == addOrEditDicomAE.TrialId,

            //    VerifyMsg = "只允许配置一条记录",
            //    IsVerify=addOrEditDicomAE.Id==null
            //};

            //  在此处拷贝automapper 映射       
            var entity = await _dicomAERepository.InsertOrUpdateAsync(addOrEditDicomAE, true, verifyExp1);

            await _trialRepository.UpdatePartialFromQueryAsync(t => t.Id == addOrEditDicomAE.TrialId, u => new Trial() { IsPACSConnect = addOrEditDicomAE.IsPACSConnect }, true);

            return ResponseOutput.Ok(entity.Id.ToString());

        }


        [HttpDelete("{dicomAEId:guid}")]
        public async Task<IResponseOutput> DeleteDicomAE(Guid dicomAEId)
        {
            var success = await _dicomAERepository.DeleteFromQueryAsync(t => t.Id == dicomAEId, true);
            return ResponseOutput.Ok();
        }


        /// <summary>
        /// 测试scp server 是否可以连接
        /// </summary>
        /// <returns></returns>
        [HttpGet("{dicomAEId:guid}")]
        public async Task<bool> TestSCPServerConnect(Guid dicomAEId)
        {
            var find = await _dicomAERepository.FirstOrDefaultAsync(t => t.Id == dicomAEId);

            if (find == null)
            {

                return false;
            }
            else
            {
                find.LatestTestTime = DateTime.Now;

                try
                {
                    var client = DicomClientFactory.Create(find.IP, find.Port, false, "test-callingAE", find.CalledAE);

                    client.NegotiateAsyncOps();

                    await client.AddRequestAsync(new DicomCEchoRequest());

                    await client.SendAsync();

                    find.IsTestOK = true;
                    await _dicomAERepository.SaveChangesAsync();

                    return true;
                }
                catch (Exception ex)
                {
                    find.IsTestOK = false;
                    await _dicomAERepository.SaveChangesAsync();

                    return false;
                }
            }


        }


    }
}
